// global variable for dialog window
var gDlWait = null;

/********************************************************/

function doLoad() {
  gDlWait = new DlWait();
  var result = gDlWait.start();
  if (!result)
    gDlWait = null;
  return;
}


function doUnload() {
  if (gDlWait) {
    gDlWait.stop();
    gDlWait = null;
  }
}

/********************************************************/

function DlWait() {
  return this;
}


DlWait.prototype = {
  
  _manager: null,
  _provider: null,
  _managerCenter: null,
  _topic: "",
  _accountId: "",
  _busy: false,
  _arg: null,
  
  /******************************************************/
  
  start: function() {
    this._arg = window.arguments[0];
    this._provider = this._arg.provider;
    this._accountId = this._arg.id;
    this._arg.aborted = false;   // assume download will not be aborted by user
    
    this._managerCenter = Components.classes["@mozdev.org/checkyesss/manager_center;1"].
                            getService(Components.interfaces.cyICheckyesssCenter);
    
    this._manager = this._managerCenter.getManager(this._provider);
    this._topic = this._managerCenter.getProviderProperties(this._provider).
                    getPropertyAsString("topic");
    
    // add observer
    var obs = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    obs.addObserver(this, this._topic, false);
    
    if (!this._manager.updateCalls(this._accountId, false)) {  //false!!!@@
      // no download needed or possible -> directly open next dialog window
      this._busy = false;
      this.stop();
      window.close();
      return false;
    }
    
    var titleElem = document.getElementById("calls-dlwait-title");
    var titleStr = titleElem.getAttribute("value");
    titleStr = titleStr.replace(/%s/, this._accountId);
    titleElem.setAttribute("value", titleStr);
    
    this._busy = true;
    return true;
  },
  
  /******************************************************/
  
  stop: function() {
    if (this._busy) {
      this._manager.abortAccess();
      this._busy = false;
    }
    
    if (this._topic) {
      try {
        var obs = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
        obs.removeObserver(this, this._topic);
      }
      catch(e) {}
    }
    
    //destroy variables
    this._manager = null;
    this._managerCenter = null;
    this._topic = null;
    this._accountId = null;
    this._arg = null;
  },
  
  /******************************************************/
  
  doCancel: function() {
    this._arg.aborted = this._busy;
    window.close();
  },
  
  /******************************************************/
  /*
  _showCallsDialog: function() {
    window.opener.openDialog("chrome://checkyesss/content/calls-show.xul",
                      "checkyesss-window-calls-show",
                      "chrome,centerscreen,resizable",
                      this._manager, this._accountId);
  },
  */
  /******************************************************/
  
  observe: function(aSubject, aTopic, aData) {
    if (aTopic == this._topic) {
      
      var arg = aData.split(/::/g);
      if (arg.length < 2)
        return;
      
      var id = arg[1];
      if (id != this._accountId)
        return;
      
      var pbar = document.getElementById("calls-dlwait-progress");
      var dialog;
      
      switch (arg[0]) {
        case "calls-progress":
          if (arg.length < 3)         // internal error
            break;
          var percent = arg[2]+"%";
          if (pbar.getAttribute("mode") != "determined")
            pbar.setAttribute("mode", "determined");
          pbar.setAttribute("value", percent);
          break;
        
        case "calls":
          this._busy = false;
          if (pbar.getAttribute("mode") != "determined")
            pbar.setAttribute("mode", "determined");
          pbar.setAttribute("value", "100%");
          dialog = document.getElementById("checkyesss-window-calls-dlwait");
          dialog.getButton("cancel").setAttribute("disabled", "true");
          // wait a bit before closing the window to show the 100% ;)
          setTimeout("gDlWait.doCancel();", 1000);
          break;
        
        case "calls-error":
          this._busy = false;
          if (arg.length < 3)
            arg[2] = "Unbekannter Fehler";
          var errbox = document.getElementById("calls-dlwait-error");
          var errtxt = arg[2].replace(/\n/, " ");
          errbox.setAttribute("value", "Fehler: "+errtxt);
          if (pbar.getAttribute("mode") != "determined")
            pbar.setAttribute("mode", "determined");
          pbar.setAttribute("value", "0%");
          dialog = document.getElementById("checkyesss-window-calls-dlwait");
          dialog.getButton("cancel").setAttribute("disabled", "true");
          // wait a bit before closing the window to show the error
          setTimeout("gDlWait.doCancel();", 3000);
          break;
          
        default:
          break;
      }
    }
  }
  
};

