// global options dialog window
var gDsWindow = null;


/**************************************/

function doLoad() {
  gDsWindow = new DsWindow();
  gDsWindow.start();
  return true;
}


function doUnload() {
  gDsWindow.stop();
  gDsWindow = null;
}


function DsWindow() {
  return this;
}


DsWindow.prototype = {
  
  _args: null,                // object contains previous period start
  
  
  start: function() {
    this._args = window.arguments[0];
    this._initDialog();
  },
  
  
  stop: function() {
    //destroy variables
    this._args = null;
  },
  
  
  // OK button pressed
  doOK: function() {
    var day, month, year;
    
    day = document.getElementById("menu-day").selectedIndex + 1;
    month = document.getElementById("menu-month").selectedIndex;
    year = document.getElementById("menu-year").selectedIndex + 2006;
    
    this._args.date = (new Date(year, month, day)).valueOf();
    
    return true;
  },
  
  
  // Cancel button pressed
  doCancel: function() {
    this._args.date = 0;
    return true;
  },
  
  
  /**
   * Initialize the dialog
   */
  
  _initDialog: function() {
    var oldDate;
    var now = new Date();
    var year, month, day;
    
    document.title += "'" + this._args.accid + "'";
    
    oldDate = (this._args.date > 0) ? new Date(this._args.date) : now;
    
    year = now.getFullYear();
    if (year > 2006) {
      var menu_year = document.getElementById("menu-year");
      var i;
      for (i = 2007; i <= year; i++)
        menu_year.appendItem(i+"", null, null);
    }
    
    day = oldDate.getDate();
    month = oldDate.getMonth();
    year = oldDate.getFullYear();
    
    if (year < 2006)
      year = 2006;
    
    document.getElementById("menu-year").selectedIndex = year - 2006;
    document.getElementById("menu-month").selectedIndex = month;
    document.getElementById("menu-day").selectedIndex = day - 1;
  },
  
  /****************/
  
  _validateDate: function() {
    var month = document.getElementById("menu-month").selectedIndex;
    var day;
    if (month == 3 || month == 5 || month == 8 || month == 10) {
      // april, june, september, november
      day = document.getElementById("menu-day").selectedIndex + 1;
      if (day > 30)
        document.getElementById("menu-day").selectedIndex = 29;
    }
    else if (month == 1) {
      // february
      var year = document.getElementById("menu-year").selectedIndex + 2006;
      day = document.getElementById("menu-day").selectedIndex + 1;
      var validDay = ((year % 4) == 0) ? 29 : 28;
      if (day > validDay)
        document.getElementById("menu-day").selectedIndex = validDay - 1;
    }
  },
  
  /****************/
  
  handleEvent: function(event) {
    if (event.target.nodeName == "menuitem")
      this._validateDate();
    
    return true;
  }
  
  
};

