// global options dialog window
var gEdWindow = null;


/**************************************/

function doLoad() {
  gEdWindow = new EdWindow();
  gEdWindow.start();
  return true;
}


function doUnload() {
  gEdWindow.stop();
  gEdWindow = null;
}


function EdWindow() {
  return this;
}


EdWindow.prototype = {
  
  _args: null,                // object contains type ("add" or "rename"),
                              // title, exist, deleted, oldname, result
  _inputOk: false,            // true when a valid name was entered
  
  
  start: function() {
    this._args = window.arguments[0];
    this._initDialog();
  },


  stop: function() {
    //destroy variables
    this._args = null;
  },


  // OK button pressed
  doOK: function() {
    var inelem;
    var isOk = true;
    var result = "";
    
    if (this._args.type == "add")
      inelem = document.getElementById("accounts");
    else       // rename
      inelem = document.getElementById("newname");
    
    result = inelem.value.replace(/^\s*(.*)\s*$/, "$1");
    result = result.replace(/[\t\n\v\f\r]/g, "");
    result = result.replace(/::/g, ":");   // not allowed (see observer data)
    if (result.length) {
      for (var i = 0; i < this._args.exist.length; i++) {
        if (result == this._args.exist[i]) {
          isOk = false;
          break;
        }
      }
    }
    else
      isOk = false;
    
    if (isOk) {
      this._args.result = result;
      return true;
    }
    else {
      var warning = document.getElementById("warning");
      warning.removeAttribute("collapsed");
      return false;
    }
  },
  
  
  // Cancel button pressed
  doCancel: function() {
    this._args.result = "";
    return true;
  },
  
  
  /**
   * Initialize the dialog
   */
  
  _initDialog: function() {
    var i;
    var pageSelector = document.getElementById("ed-type");
    document.title = this._args.title;
    
    if (this._args.type == "add") {
      pageSelector.selectedIndex = 0;
      
      var list = document.getElementById("accounts");
      for (i = 0; i < this._args.deleted.length; i++)
        list.appendItem(this._args.deleted[i], this._args.deleted[i]);
      //dump("deleted: ");
      //for (i = 0; i < this._args.deleted.length; i++)
      //  dump(this._args.deleted[i] + ", ");
      //dump("\n");
      
      list.selectedIndex = -1;
      list.inputField.value = "";        // clear input
      list.inputField.focus();
    }
    else {      // rename
      pageSelector.selectedIndex = 1;
      
      text = document.getElementById("newname");
      text.value = this._args.oldname;
      text.select();
      text.focus();
    }
    
    var warning = document.getElementById("warning");
    warning.collapsed = "true";
  },
  
  /****************/
  
  handleEvent: function(event) {
    var warning = document.getElementById("warning");
    warning.collapsed = "true";
    
    return true;
  }
  
  
};

